## avogadrolibs 1.100.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24 FATAL_ERROR)

project(AvogadroLibs)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Use C++17 when possible
option(PYTHON_WHEEL_BUILD "Is this a Python wheel build?" OFF)
mark_as_advanced(PYTHON_WHEEL_BUILD)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_EXTENSIONS False)
# Set symbol visibility defaults for all targets.
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN True)

include(BuildType)
include(BuildLocation)
include(CompilerFlags)
include(InstallLocation)
include(DetermineVersion)

# Set up our version.
set(AvogadroLibs_VERSION_MAJOR   "1")
set(AvogadroLibs_VERSION_MINOR   "100")
set(AvogadroLibs_VERSION_PATCH   "0")
set(AvogadroLibs_VERSION
  "${AvogadroLibs_VERSION_MAJOR}.${AvogadroLibs_VERSION_MINOR}.${AvogadroLibs_VERSION_PATCH}")
find_package(Git)
determine_version(${AvogadroLibs_SOURCE_DIR} ${GIT_EXECUTABLE} "AvogadroLibs")

# path for data / fragment files which could be overriden by package maintainers
# by default we assume we're using the openchemistry superbuild layout
# .. this is used by the fragment library, molecules, crystals, etc.
set(AvogadroLibs_SOURCEDATA_DIR "${AvogadroLibs_SOURCE_DIR}/..")

option(BUILD_SHARED_LIBS "Build with shared libraries" ON)

# Before any plugins are defined, and before any add_subdirectory calls:
set_property(GLOBAL PROPERTY AvogadroLibs_PLUGINS)
set_property(GLOBAL PROPERTY AvogadroLibs_STATIC_PLUGINS)

if(MSVC)
  add_definitions("-D_CRT_SECURE_NO_WARNINGS" "-DNOMINMAX -D_USE_MATH_DEFINES")
  # Ensure __cplusplus is correct, otherwise it defaults to 199711L which isn't true
  # https://docs.microsoft.com/en-us/cpp/build/reference/zc-cplusplus?view=msvc-160
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")

  message(STATUS "Setting MSVC debug information format to 'Embedded'")
  set(CMAKE_MSVC_DEBUG_INFORMATION_FORMAT "$<$<CONFIG:Debug,RelWithDebInfo>:Embedded>")

  set(CMAKE_VS_GLOBALS
    "UseMultiToolTask=true"
    "DebugInformationFormat=OldStyle"
  )
endif()

option(ENABLE_TESTING "Enable testing and building the tests." OFF)
option(TEST_QTGL "Build the Qt OpenGL test application" OFF)
option(ENABLE_TRANSLATIONS "Enable building translations with Qt5 Linguist" OFF)
option(USE_OPENGL "Enable libraries that use OpenGL" ON)
option(USE_HDF5 "Enable optional HDF5 features" OFF)
option(USE_QT "Enable libraries that use Qt 5 or 6" ON)
option(USE_VTK "Enable libraries that use VTK" OFF)
option(USE_LIBARCHIVE "Enable optional Libarchive features" ON)
option(USE_LIBMSYM "Enable optional features using libmsym" ON)
option(USE_SPGLIB "Enable optional features using spglib" ON)
option(USE_MMTF "Enable optional features using mmtf" ON)
option(USE_PYTHON "Use Python to wrap some of our API" OFF)
option(USE_EXTERNAL_NLOHMANN "Use an externally-provided version of the nlohmann JSON library" OFF)
option(USE_EXTERNAL_PUGIXML "Use an externally-provided version of pugixml" OFF)
option(USE_EXTERNAL_STRUCT "Use an externally-provided version of the struct binary data formatting library" OFF)
set(QT_VERSION "5" CACHE STRING "What major version of Qt")
set(QT_VERSIONS_SUPPORTED 5 6)
set_property(CACHE QT_VERSION PROPERTY STRINGS 5 6)
if(NOT QT_VERSION IN_LIST QT_VERSIONS_SUPPORTED)
  message(FATAL_ERROR "Qt version must be one of ${QT_VERSIONS_SUPPORTED}")
endif()

add_subdirectory(thirdparty)
add_subdirectory(utilities)
add_subdirectory(avogadro)

if(ENABLE_TESTING)
  include(CTest)
  enable_testing()
  add_subdirectory(tests)
endif()

option(BUILD_DOCUMENTATION "Build project documentation" OFF)

if(BUILD_DOCUMENTATION)
  add_subdirectory(docs)
endif()

if(USE_PYTHON)
  add_subdirectory(python)
endif()

if(ENABLE_TRANSLATIONS)
  find_package(Qt5LinguistTools)
endif()

# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  install(
    FILES
      README.md
      CONTRIBUTING.md
      LICENSE
    DESTINATION "${INSTALL_DOC_DIR}/avogadrolibs")
endif()

# After all add_subdirectory calls, so the list of plugins is complete:
get_property(AvogadroLibs_PLUGINS GLOBAL PROPERTY AvogadroLibs_PLUGINS)
get_property(AvogadroLibs_STATIC_PLUGINS GLOBAL
  PROPERTY AvogadroLibs_STATIC_PLUGINS)

configure_file(${AvogadroLibs_SOURCE_DIR}/cmake/CTestCustom.cmake.in
  ${AvogadroLibs_BINARY_DIR}/CTestCustom.cmake)

configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/AvogadroLibsConfig.cmake.in"
  "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfig.cmake" @ONLY)
configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/AvogadroLibsConfigVersion.cmake.in"
  "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfigVersion.cmake" @ONLY)

# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  install(FILES
    "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfig.cmake"
    "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfigVersion.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Findlibmsym.cmake"
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/avogadrolibs")
  install(EXPORT "AvogadroLibsTargets"
    NAMESPACE Avogadro::
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/avogadrolibs")
endif()

=== avogadro/CMakeLists.txt ===
include(GenerateExportHeader)

# May want to adjust the name, this more performs boilerplate library stuff now.
function(avogadro_add_library name)
  # Add an alias target to expose to other targets.
  add_library(Avogadro::${name} ALIAS ${name})
  # Use the new AUTOMOC support for Qt libraries (CMake 2.8.6).
  if(${name} MATCHES "^Qt")
    set_target_properties(${name} PROPERTIES AUTOMOC TRUE)
  endif()
  if(BUILD_SHARED_LIBS)
  set_target_properties(${name}
    PROPERTIES
      OUTPUT_NAME Avogadro${name}
      VERSION "${AvogadroLibs_VERSION_MAJOR}.${AvogadroLibs_VERSION_MINOR}.${AvogadroLibs_VERSION_PATCH}"
      SOVERSION ${AvogadroLibs_VERSION_MAJOR})
  endif()
  string(TOLOWER ${name} _lower_name)
  string(TOUPPER ${name} _upper_name)
  # Generate the necessary export headers.
  generate_export_header(${name}
    BASE_NAME AVOGADRO${_upper_name}
    EXPORT_FILE_NAME avogadro${_lower_name}export.h)
  target_sources(${name} PUBLIC FILE_SET HEADERS
    FILES "${CMAKE_CURRENT_BINARY_DIR}/avogadro${_lower_name}export.h")
  # Set up the build and install include directories for the target.
  target_include_directories(${name}
    PUBLIC
      "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>"
      "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
      "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
      "$<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>")

  # Install the target and its headers.
  install(TARGETS ${name}
    EXPORT "AvogadroLibsTargets"
    FILE_SET HEADERS DESTINATION "${INSTALL_INCLUDE_DIR}/avogadro"
    RUNTIME DESTINATION "${INSTALL_RUNTIME_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIBRARY_DIR}"
    ARCHIVE DESTINATION "${INSTALL_ARCHIVE_DIR}"
    INCLUDES DESTINATION "${INSTALL_INCLUDE_DIR}")
endfunction()

# Simple wrapper to collect boilerplate for adding headers to targets.
function(avogadro_headers _name)
  target_sources(${_name} PUBLIC
    FILE_SET HEADERS
    BASE_DIRS
      ${AvogadroLibs_SOURCE_DIR}/avogadro
      ${AvogadroLibs_BINARY_DIR}/avogadro
    FILES ${ARGN})
endfunction()

add_subdirectory(core)
add_subdirectory(calc)
add_subdirectory(io)
add_subdirectory(quantumio)
# SKBUILD is set for binary wheel
if(NOT SKBUILD)
  add_subdirectory(command)
endif()
if(USE_OPENGL)
  add_subdirectory(rendering)
endif()

if(USE_QT)
  if (NOT MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
  endif()

  add_subdirectory(qtgui)
  if(USE_OPENGL)
    add_subdirectory(qtopengl)
  endif()
  # Add unconditionally as this talks to MoleQueue, but doesn't depend on it.
  add_subdirectory(molequeue)
  if(USE_VTK)
    add_subdirectory(vtk)
  endif()
  add_subdirectory(qtplugins)
endif()

=== avogadro/core/CMakeLists.txt ===
find_package(Eigen3 REQUIRED)

# configure the version header
configure_file("${PROJECT_SOURCE_DIR}/cmake/version.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/version.h")

# Separate out header only components into an interface library.
add_library(Headers INTERFACE)
add_library(Avogadro::Headers ALIAS Headers)
target_include_directories(Headers
  INTERFACE
    "$<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>")

target_sources(Headers PUBLIC
  FILE_SET HEADERS
  BASE_DIRS ${PROJECT_SOURCE_DIR}
  FILES
    angletools.h
    angleiterator.h
    array.h
    avogadrocore.h
    color3f.h
    coordinateset.h
    matrix.h
    types.h
    utilities.h
    vector.h
)
target_link_libraries(Headers INTERFACE Eigen3::Eigen)
install(TARGETS Headers
  EXPORT "AvogadroLibsTargets"
  FILE_SET HEADERS DESTINATION "${INSTALL_INCLUDE_DIR}")

# Now add the main core library for Avogadro.
add_library(Core)

avogadro_headers(Core
  atom.h
  atomtyper.h
  atomtyper-inline.h
  atomutilities.h
  basisset.h
  bond.h
  coordinateblockgenerator.h
  crystaltools.h
  cube.h
  dihedraliterator.h
  elements.h
  gaussianset.h
  gaussiansettools.h
  graph.h
  layer.h
  layermanager.h
  mesh.h
  molecule.h
  mutex.h
  nameatomtyper.h
  neighborperceiver.h
  residue.h
  ringperceiver.h
  secondarystructure.h
  slaterset.h
  slatersettools.h
  spacegroups.h
  symbolatomtyper.h
  unitcell.h
  variant.h
  variant-inline.h
  variantmap.h
  "${CMAKE_CURRENT_BINARY_DIR}/version.h"
)

target_sources(Core PRIVATE
  angleiterator.cpp
  atomutilities.cpp
  coordinateblockgenerator.cpp
  crystaltools.cpp
  cube.cpp
  elements.cpp
  dihedraliterator.cpp
  gaussianset.cpp
  gaussiansettools.cpp
  graph.cpp
  layer.cpp
  layermanager.cpp
  mesh.cpp
  mdlvalence_p.h
  molecule.cpp
  mutex.cpp
  nameatomtyper.cpp
  neighborperceiver.cpp
  residue.cpp
  ringperceiver.cpp
  secondarystructure.cpp
  slaterset.cpp
  slatersettools.cpp
  spacegroups.cpp
  symbolatomtyper.cpp
  unitcell.cpp
  variantmap.cpp
  version.cpp
)

# We currently build core without shared_mutex for Python wheels.
if(NOT PYTHON_WHEEL_BUILD)
  avogadro_headers(Core sharedmutex.h)
  target_sources(Core PRIVATE sharedmutex.cpp)
endif()

if(USE_SPGLIB)
  find_package(Spglib REQUIRED)
  avogadro_headers(Core avospglib.h)
  target_sources(Core PRIVATE avospglib.cpp)
  target_link_libraries(Core PRIVATE Spglib::symspg)
endif()

# The std::shared_mutex class needs pthreads on Linux.
if(UNIX AND NOT APPLE AND NOT PYTHON_WHEEL_BUILD)
  find_package(Threads)
  target_link_libraries(Core PRIVATE ${CMAKE_THREAD_LIBS_INIT})
endif()

avogadro_add_library(Core)
target_link_libraries(Core
  PUBLIC Avogadro::Headers)

=== avogadro/qtgui/CMakeLists.txt ===
if(QT_VERSION EQUAL 6)
  find_package(Qt6 COMPONENTS Widgets Concurrent REQUIRED)
else()
  find_package(Qt5 COMPONENTS Widgets Concurrent REQUIRED)
endif()

# Provide some simple API to find the plugins, scripts, etc.
if(APPLE)
  # It is a special case, the app bundle logic breaks the relative pathing.
  add_definitions(-DAvogadroLibs_LIB_DIR=\"lib\")
  add_definitions(-DAvogadroLibs_DATA_DIR=\"share\")
else()
  add_definitions(-DAvogadroLibs_LIB_DIR=\"${INSTALL_LIBRARY_DIR}\")
  add_definitions(-DAvogadroLibs_DATA_DIR=\"${INSTALL_DATA_DIR}\")
endif()

if(USE_SPGLIB)
  add_definitions(-DUSE_SPGLIB)
endif()

# Find python for input generator scripts:
find_package(PythonInterp 3)

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h.in"
"namespace Avogadro {
static const char *pythonInterpreterPath = \"${PYTHON_EXECUTABLE}\";
}
")
configure_file("${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h")

add_library(QtGui)

avogadro_headers(QtGui
  backgroundfileformat.h
  colorbutton.h
  containerwidget.h
  customelementdialog.h
  elementtranslator.h
  extensionplugin.h
  filebrowsewidget.h
  fileformatdialog.h
  gaussiansetconcurrent.h
  generichighlighter.h
  hydrogentools.h
  insertfragmentdialog.h
  interfacescript.h
  interfacewidget.h
  jsonwidget.h
  layermodel.h
  rwlayermanager.h
  meshgenerator.h
  molecule.h
  moleculemodel.h
  multiviewwidget.h
  periodictableview.h
  persistentatom.h
  persistentbond.h
  pluginlayermanager.h
  pythonscript.h
  richtextdelegate.h
  rwmolecule.h
  sceneplugin.h
  scenepluginmodel.h
  scriptloader.h
  slatersetconcurrent.h
  sortfiltertreeproxymodel.h
  toolplugin.h
  utilities.h
  viewfactory.h
)

target_sources(QtGui PRIVATE
  backgroundfileformat.cpp
  colorbutton.cpp
  containerwidget.cpp
  customelementdialog.cpp
  elementdetail_p.cpp
  elementitem_p.cpp
  elementtranslator.cpp
  extensionplugin.cpp
  filebrowsewidget.cpp
  fileformatdialog.cpp
  gaussiansetconcurrent.cpp
  generichighlighter.cpp
  hydrogentools.cpp
  insertfragmentdialog.cpp
  interfacescript.cpp
  interfacewidget.cpp
  jsonwidget.cpp
  layermodel.cpp
  richtextdelegate.cpp
  rwlayermanager.cpp
  meshgenerator.cpp
  molecule.cpp
  moleculemodel.cpp
  multiviewwidget.cpp
  periodictablescene_p.cpp
  periodictableview.cpp
  pluginlayermanager.cpp
  pythonscript.cpp
  rwmolecule.cpp
  sceneplugin.cpp
  scenepluginmodel.cpp
  scriptloader.cpp
  slatersetconcurrent.cpp
  sortfiltertreeproxymodel.cpp
  toolplugin.cpp
  utilities.cpp
  viewfactory.cpp
)

set(UIS
  customelementdialog.ui
  insertfragmentdialog.ui
)
qt_wrap_ui(UI_SOURCES ${UIS})
target_sources(QtGui PRIVATE ${UI_SOURCES})

set(RCS
  qtgui.qrc
)
qt_add_resources(RC_SOURCES ${RCS})
target_sources(QtGui PRIVATE ${RC_SOURCES})

avogadro_add_library(QtGui)
target_link_libraries(QtGui PUBLIC Avogadro::IO Qt::Widgets Qt::Concurrent)

=== avogadro/qtplugins/CMakeLists.txt ===
find_package(Qt${QT_VERSION} COMPONENTS Widgets Network Concurrent REQUIRED)
if(QT_VERSION EQUAL 6)
  find_package(Qt6 COMPONENTS OpenGLWidgets REQUIRED)
endif()

if(WIN32)
  # used for HTTPS (e.g., PQR, downloads, etc.)
  find_package(OpenSSL REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Modify the output directory for the build tree.
set(original_library_output_dir "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
  "${original_library_output_dir}/avogadro2/plugins")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
  "${original_library_output_dir}/avogadro2/staticplugins")

# Optionally build all plugins statically.
option(BUILD_STATIC_PLUGINS "Build static plugins by default" ON)

# Allow GPL plugins to be disabled.
option(BUILD_GPL_PLUGINS
  "Build plugins that are licensed under the GNU Public License." OFF)

# Create a plugin for Avogadro.
# name is the name of the plugin, this will be the name of the target created.
# description Free text description of the plugin.
# type The base class of the plugin.
# header is the header(s) for the class to be instantiated for the plugin.
# pluginClass is the class to be instantiated for the plugin.
# sources is the list of source files for the plugin.
# uis is the list of UI files that need to be compiled (optional).
# rcs is the list of qrc files that need to be compiled (optional).
function(avogadro_plugin name description type header pluginClass sources)
  set(uis "")
  set(rcs "")
  if(${ARGC} GREATER 6)
    set(uis ${ARGV6})
  endif()
  if(${ARGC} GREATER 7)
    set(rcs ${ARGV7})
  endif()
  qt_wrap_ui(ui_srcs ${uis})
  qt_add_resources(rc_srcs ${rcs})
  unset(PluginIncludes)
  foreach(_header ${header})
    set(PluginIncludes
      "${PluginIncludes}#include \"${CMAKE_CURRENT_SOURCE_DIR}/${_header}\"\n")
  endforeach()
  set(PluginName "${name}")
  set(PluginDescription "${description}")
  set(PluginType "${type}")
  set(PluginClass "${pluginClass}")
  configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/avogadroplugin.cpp.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${name}Plugin.cpp")

  # Figure out which type of plugin is being added, and put it in the right list
  if(BUILD_STATIC_PLUGINS)
    set(_plugin_object "STATIC")
    set_property(GLOBAL APPEND PROPERTY AvogadroLibs_STATIC_PLUGINS ${name})
    if(rcs)
      get_filename_component(_name_we ${rcs} NAME_WE)
      set_property(GLOBAL APPEND PROPERTY AvogadroLibs_STATIC_RCS ${_name_we})
    endif()
  else()
    set(_plugin_object "MODULE")
    set_property(GLOBAL APPEND PROPERTY AvogadroLibs_PLUGINS ${name})
  endif()

  add_library(${name}
    ${_plugin_object}
    ${sources}
    ${ui_srcs}
    ${rc_srcs}
    ${name}Plugin.cpp
  )
  target_link_libraries(${name} PRIVATE Avogadro::QtGui)

  if("${_plugin_object}" STREQUAL "STATIC")
    set_target_properties(${name} PROPERTIES COMPILE_DEFINITIONS
      "QT_STATICPLUGIN")
    if(UNIX)
      set_target_properties(${name} PROPERTIES POSITION_INDEPENDENT_CODE ON)
    endif()
  endif()

  set_target_properties(${name} PROPERTIES AUTOMOC TRUE PREFIX "")
  install(TARGETS ${name}
    EXPORT "AvogadroLibsTargets"
    RUNTIME DESTINATION "${INSTALL_RUNTIME_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIBRARY_DIR}/avogadro2/plugins"
    ARCHIVE DESTINATION "${INSTALL_ARCHIVE_DIR}/avogadro2/staticplugins")
endfunction()

# Now to make the plugins.
add_subdirectory(3dmol)
add_subdirectory(alchemy)
add_subdirectory(aligntool)
add_subdirectory(apbs)
add_subdirectory(applycolors)
add_subdirectory(bondcentrictool)
add_subdirectory(bonding)
add_subdirectory(cartoons)
add_subdirectory(centroid)
add_subdirectory(configurepython)
add_subdirectory(coordinateeditor)
add_subdirectory(copypaste)
add_subdirectory(cp2kinput)
add_subdirectory(crystal)
add_subdirectory(customelements)
add_subdirectory(dipole)
add_subdirectory(editor)
add_subdirectory(fetchpdb)
add_subdirectory(focus)
add_subdirectory(forcefield)
add_subdirectory(gamessinput)
add_subdirectory(hydrogens)
add_subdirectory(importpqr)
add_subdirectory(insertdna)
add_subdirectory(insertfragment)
add_subdirectory(label)
add_subdirectory(lammpsinput)
add_subdirectory(lineformatinput)
add_subdirectory(manipulator)
add_subdirectory(measuretool)
add_subdirectory(molecularproperties)
add_subdirectory(navigator)
add_subdirectory(networkdatabases)
add_subdirectory(openbabel)
add_subdirectory(openmminput)
add_subdirectory(playertool)
add_subdirectory(ply)
add_subdirectory(povray)
add_subdirectory(propertytables)
add_subdirectory(resetview)
add_subdirectory(select)
add_subdirectory(selectiontool)
if(USE_SPGLIB)
  add_subdirectory(spacegroup)
endif()
add_subdirectory(surfaces)
add_subdirectory(svg)
add_subdirectory(templatetool)
add_subdirectory(vibrations)
add_subdirectory(vrml)

# Plugins that require VTK
if(USE_VTK)
  add_subdirectory(coloropacitymap)
  add_subdirectory(spectra)
  add_subdirectory(plotpdf)
  add_subdirectory(plotrmsd)
  add_subdirectory(plotxrd)
  if(USE_SPGLIB)
    add_subdirectory(yaehmop)
  endif()
endif()

# script plugins (input generators, etc.)
add_subdirectory(commandscripts)
add_subdirectory(quantuminput)
add_subdirectory(scriptcharges)
add_subdirectory(scriptfileformats)

if(USE_LIBARCHIVE)
  add_subdirectory(plugindownloader)
endif()

if(USE_LIBMSYM AND QT_VERSION EQUAL 5)
  # QStyleOptionViewItemV4 is not in Qt6, needs investigation
  add_subdirectory(symmetry)
endif()

# The scene plugins
add_subdirectory(ballandstick)
add_subdirectory(closecontacts)
add_subdirectory(force)
add_subdirectory(licorice)
add_subdirectory(meshes)
add_subdirectory(noncovalent)
add_subdirectory(vanderwaals)
add_subdirectory(wireframe)
if (USE_OPENGL)
  # needs some raw OpenGL code
  add_subdirectory(overlayaxes)
endif()

# other optional plugins
if(BUILD_GPL_PLUGINS AND QT_VERSION EQUAL 5)
  # qtaimcurvature.h/cpp contains GPL licensed code:
  add_subdirectory(qtaim)
endif()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${original_library_output_dir}")

# Add all of the static plugins to the initialization file.
get_property(AvogadroLibs_STATIC_PLUGINS GLOBAL
  PROPERTY AvogadroLibs_STATIC_PLUGINS)
get_property(AvogadroLibs_STATIC_RCS GLOBAL
  PROPERTY AvogadroLibs_STATIC_RCS)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "// Automatically generated file. Do not edit.
#ifndef AVOGADRO_STATIC_QTPLUGINS_H
#define AVOGADRO_STATIC_QTPLUGINS_H

#include <QtCore/QtPlugin>\n\n")

foreach(_plugin ${AvogadroLibs_STATIC_PLUGINS})
  file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
    "Q_IMPORT_PLUGIN(${_plugin}Factory)\n")
endforeach()
file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "\nvoid initAvogadroPluginResources() {\n")
foreach(_rcs ${AvogadroLibs_STATIC_RCS})
  file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
    "  Q_INIT_RESOURCE(${_rcs});\n")
endforeach()
file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "}\n\n")

file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "\n#endif // AVOGADRO_STATIC_QTPLUGINS_H\n")

# Configure the static plugin header, ensuring it only changes if the contents
# are modified - otherwise the original timestamp will be maintained.
configure_file("${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h")

# Now to build the plugin library, which can also statically link plugins
# and initialize them for the application. If Avogadro is built statically
# then the static plugin header must be included by the application.
add_library(QtPlugins)
avogadro_headers(QtPlugins
  pluginmanager.h
  pluginfactory.h
  "${CMAKE_CURRENT_BINARY_DIR}/avogadrostaticqtplugins.h"
)

target_sources(QtPlugins PRIVATE
  pluginmanager.cpp
)

avogadro_add_library(QtPlugins ${HEADERS} ${SOURCES})
target_link_libraries(QtPlugins PUBLIC Qt::Core
  PRIVATE ${AvogadroLibs_STATIC_PLUGINS} Avogadro::QtGui Avogadro::Calc)

if(QT_VERSION EQUAL 6)
  target_link_libraries(QtPlugins PRIVATE Qt6::OpenGLWidgets Qt6::Network)
endif()

=== avogadro/quantumio/CMakeLists.txt ===
add_library(QuantumIO)

avogadro_headers(QuantumIO
  gamessus.h
  gaussianfchk.h
  gaussiancube.h
  genericoutput.h
  molden.h
  mopacaux.h
  nwchemjson.h
  nwchemlog.h
  orca.h
)

# Source files for our data.
target_sources(QuantumIO PRIVATE
  gamessus.cpp
  gaussianfchk.cpp
  gaussiancube.cpp
  genericoutput.cpp
  molden.cpp
  mopacaux.cpp
  nwchemjson.cpp
  nwchemlog.cpp
  orca.cpp
)

avogadro_add_library(QuantumIO)
target_link_libraries(QuantumIO
  PUBLIC Avogadro::IO
  PRIVATE nlohmann_json::nlohmann_json
)

=== avogadro/vtk/CMakeLists.txt ===
find_package(OpenGL REQUIRED)
find_package(GLEW REQUIRED)

if(WIN32 AND NOT BUILD_SHARED_LIBS)
  add_definitions(-DGLEW_STATIC)
endif()

find_package(Qt${QT_VERSION} COMPONENTS Widgets REQUIRED)

find_package(VTK
  COMPONENTS
  RenderingOpenGL2 GUISupportQt DomainsChemistry
  RenderingVolumeOpenGL2 ViewsCore RenderingFreeType
  ChartsCore ViewsContext2D RenderingContextOpenGL2
  REQUIRED)

add_library(Vtk)

avogadro_headers(Vtk
  chartdialog.h
  chartwidget.h
  qvtkwidget.h
  vtkAvogadroActor.h
  vtkglwidget.h
)

target_sources(Vtk PRIVATE
  chartdialog.cpp
  chartwidget.cpp
  qvtkwidget.cpp
  vtkAvogadroActor.cpp
  vtkglwidget.cpp
)

avogadro_add_library(Vtk ${HEADERS} ${SOURCES})
set_target_properties(Vtk PROPERTIES AUTOMOC TRUE)
target_link_libraries(Vtk PUBLIC Avogadro::Rendering Avogadro::QtGui
  VTK::RenderingOpenGL2 VTK::GUISupportQt VTK::RenderingVolumeOpenGL2
  VTK::RenderingFreeType VTK::InteractionStyle VTK::ChartsCore VTK::ViewsContext2D
  VTK::RenderingContextOpenGL2 VTK::DomainsChemistryOpenGL2 Qt::Widgets
  PRIVATE GLEW::GLEW OpenGL::GL)

vtk_module_autoinit(TARGETS Vtk MODULES
  VTK::RenderingOpenGL2 VTK::GUISupportQt VTK::RenderingVolumeOpenGL2
  VTK::RenderingFreeType VTK::InteractionStyle VTK::ChartsCore VTK::ViewsContext2D
  VTK::RenderingContextOpenGL2 VTK::DomainsChemistryOpenGL2)

=== tests/core/CMakeLists.txt ===
# Specify the name of each test (the Test will be appended where needed).
set(tests
  Array
  Atom
  AtomTyper
  BasisSet
  Bond
  CoordinateBlockGenerator
  CoordinateSet
  Cube
  Eigen
  Element
  Graph
  Mesh
  Molecule
  Mutex
  NeighborPerceiver
  RingPerceiver
  Spacegroup
  Utilities
  UnitCell
  Variant
  VariantMap
  )

# Build up the source file names.
set(testSrcs "")
foreach(TestName ${tests})
  message(STATUS "Adding ${TestName} test.")
  string(TOLOWER ${TestName} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()
message(STATUS "Test source files: ${testSrcs}")

# Add a single executable for all of our tests.
add_executable(AvogadroTests ${testSrcs})
target_link_libraries(AvogadroTests Avogadro::Core
  ${GTEST_BOTH_LIBRARIES} ${EXTRA_LINK_LIB})

# Now add all of the tests, using the gtest_filter argument so that only those
# cases are run in each test invocation.
foreach(TestName ${tests})
  add_test(NAME "Core-${TestName}"
    COMMAND AvogadroTests "--gtest_filter=${TestName}Test.*")
endforeach()

=== tests/qtgui/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_BINARY_DIR}"
  "${AvogadroLibs_BINARY_DIR}/avogadro/qtgui"
  "${AvogadroLibs_BINARY_DIR}/avogadro/molequeue"
  "${AvogadroLibs_SOURCE_DIR}/tests/core")

find_package(Qt${QT_VERSION} COMPONENTS Widgets Network Test REQUIRED)

# Find python interpreter for input generator
find_package(PythonInterp 3)

# Setup config file with data location
if(AVOGADRO_DATA_ROOT)
  set(AVOGADRO_DATA ${AVOGADRO_DATA_ROOT})
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/qtguitests.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/qtguitests.h" @ONLY)

# Specify the name of each test (the Test will be appended where needed).
set(tests
  GenericHighlighter
  HydrogenTools
  # GitHub is showing this as a free() bug
  # TODO: Fix this
  # Molecule
  RWMolecule
  )

if (BUILD_MOLEQUEUE)
  # Pull in MoleQueue
  find_package(MoleQueue REQUIRED NO_MODULE)
  include_directories(${MoleQueue_INCLUDE_DIRS})
  list(APPEND tests
    MoleQueueQueueListModel
  )
  set(MoleQueueLink Avogadro::MoleQueue MoleQueueClient)
endif()

if(PYTHON_EXECUTABLE AND AVOGADRO_DATA)
  list(APPEND tests
# FIXME: These tests are broken
#    FileBrowseWidget
#    InputGenerator
#    InputGeneratorWidget
  )
endif()

# Build up the source file names.
set(testSrcs "")
foreach(TestName ${tests})
  message(STATUS "Adding ${TestName} test.")
  string(TOLOWER ${TestName} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()

# Add a single executable for all of our tests.
add_executable(AvogadroQtGuiTests ${testSrcs})
target_link_libraries(AvogadroQtGuiTests Avogadro::QtGui ${MoleQueueLink}
 ${GTEST_BOTH_LIBRARIES} ${EXTRA_LINK_LIB}
 Qt${QT_VERSION}::Widgets Qt${QT_VERSION}::Test)

# Now add all of the tests, using the gtest_filter argument so that only those
# cases are run in each test invocation.
foreach(TestName ${tests})
  add_test(NAME "QtGui-${TestName}"
    COMMAND AvogadroQtGuiTests "--gtest_filter=${TestName}Test.*")
endforeach()

=== tests/qtopengl/CMakeLists.txt ===
include_directories("${AvogadroLibs_BINARY_DIR}/avogadro/qtgui"
  "${AvogadroLibs_BINARY_DIR}/avogadro/rendering"
  "${AvogadroLibs_BINARY_DIR}/avogadro/qtopengl"
  "${CMAKE_CURRENT_BINARY_DIR}")

find_package(OpenGL REQUIRED)
include_directories(SYSTEM ${OPENGL_INCLUDE_DIR})

find_package(Qt5 COMPONENTS Widgets REQUIRED)
include_directories(SYSTEM ${Qt5Widgets_INCLUDE_DIRS})
add_definitions(${Qt5Widgets_DEFINITIONS})

# We want to find some parts of VTK in order to do image comparisons.
find_package(VTK
  COMPONENTS vtkImagingCore vtkRenderingQt vtkIOImage
  NO_MODULE REQUIRED)
include_directories(SYSTEM ${VTK_INCLUDE_DIRS})

if(AVOGADRO_DATA_ROOT)
  set(AVOGADRO_DATA ${AVOGADRO_DATA_ROOT})
else()
  message("No data root found, please set to run the tests.")
  return()
endif()

# Setup config file with data location
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/qtopengltests.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/qtopengltests.h" @ONLY)

# List of tests to be added, the name will be changed to lower case with
# test.cpp appended. The main function of each test is expected to be lower
# cased version with test appended, e.g. GLWidget -> glwidgettest.
set(tests
  GLWidget
  QtTextLabel
  QtTextRenderStrategy
)

foreach(test ${tests})
  string(TOLOWER ${test} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()
create_test_sourcelist(testDriver qtopengltests.cpp ${testSrcs})

add_executable(AvogadroQtOpenGLTests ${testDriver})

target_link_libraries(AvogadroQtOpenGLTests
  Avogadro::QtOpenGL
  vtkImagingCore
  vtkIOImage
  vtkRenderingQt)

foreach(test ${tests})
  string(TOLOWER ${test} testname)
  add_test(NAME "QtOpenGL-${test}"
    COMMAND
      AvogadroQtOpenGLTests "${testname}test"
      "--baseline" "${AVOGADRO_DATA_ROOT}/baselines/avogadro/qtopengl"
      "--temporary" "${PROJECT_BINARY_DIR}/Testing/Temporary")
endforeach()

=== tests/rendering/CMakeLists.txt ===
# Specify the name of each test (the Test will be appended where needed).
set(tests
  Camera
  Node
  SphereGeometry
  )

find_package(OpenGL REQUIRED)
include_directories(SYSTEM ${OPENGL_INCLUDE_DIR})

include_directories("${CMAKE_CURRENT_BINARY_DIR}"
  "${AvogadroLibs_BINARY_DIR}/avogadro/rendering")

# Build up the source file names.
set(testSrcs "")
foreach(TestName ${tests})
  message(STATUS "Adding ${TestName} test.")
  string(TOLOWER ${TestName} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()
message(STATUS "Test source files: ${testSrcs}")

# Add a single executable for all of our tests.
add_executable(AvogadroRenderingTests ${testSrcs})
target_link_libraries(AvogadroRenderingTests Avogadro::Rendering
  ${GTEST_BOTH_LIBRARIES} ${EXTRA_LINK_LIB})

# Now add all of the tests, using the gtest_filter argument so that only those
# cases are run in each test invocation.
foreach(TestName ${tests})
  add_test(NAME "Rendering-${TestName}"
    COMMAND AvogadroRenderingTests "--gtest_filter=${TestName}Test.*")
endforeach()

=== thirdparty/libgwavi/CMakeLists.txt ===
add_library(gwavi STATIC gwavi.c fileio.c avi-utils.c)
set_target_properties(gwavi PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
target_include_directories(gwavi PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
install(TARGETS gwavi
  EXPORT "AvogadroLibsTargets"
  RUNTIME DESTINATION "${INSTALL_RUNTIME_DIR}/avogadro2"
  LIBRARY DESTINATION "${INSTALL_LIBRARY_DIR}/avogadro2"
  ARCHIVE DESTINATION "${INSTALL_ARCHIVE_DIR}/avogadro2")

=== debian/changelog ===
avogadrolibs (1.100.0-1) unstable; urgency=medium

  * New upstream release.
    - applies debian patches:
      fetch_PDB_PR1642.patch
      fetch_PDB_error_check_PR1646.patch
      fix_startup_crash_PR1621.patch
      set_fragments_PR1612.patch
  * update data files for crystals, fragments, molecules to 1.100.0
  * build against Qt6
  * drop deprecated debian patches
    - fix_test_qtgui.patch (replaced by updates upstream and in
      tests_find_avogadrolibs.patch)
    - tests_skip_spacegroup_HallNumber0.patch (tests are now passing)
  * debian patch doc_mathjax.patch: retain @2 suffix in mathjax path
  * remove .gitignore file installed with fragments by dh_auto_install
  * libavogadro2-1t64.lintian-overrides: drop redundant override
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 06 Feb 2025 19:13:21 +0900

=== debian/control ===
Source: avogadrolibs
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               libarchive-dev,
               libeigen3-dev (>> 3.3),
               libgl2ps-dev,
               libglew-dev,
               libglvnd-dev,
               libhdf5-dev,
               libjs-mathjax,
               libsymspg-dev,
               molequeue, libmolequeue-dev,
               openbabel,
               pkgconf,
               python3-dev,
               python3-pybind11,
               python3-skbuild,
               python3-wheel,
               qt6-base-dev,
               libqt6opengl6-dev,
               libqt6svg6-dev,
               qt6-tools-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen,
 graphviz
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debichem-team/avogadrolibs
Vcs-Git: https://salsa.debian.org/debichem-team/avogadrolibs.git
Homepage: https://avogadro.cc/

Package: avogadro-utils
Architecture: any
Depends: libavogadro2-1t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: avogadro (>= 1.90)
Replaces: avogadro (<< 1.90)
Breaks: avogadro (<< 1.90)
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides avogadro utility programs:
   avobabel
   avocjsontocml
   bodrparse
   encodefile
   qube
   resdataparse

Package: libavogadro2-1t64
Provides: ${t64:Provides}
Replaces: libavogadro2-1
Breaks: libavogadro2-1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: libavogadro-data, python3:any, python3-cclib
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the shared libraries, plugins and functionality scripts.

Package: libavogadro-dev
Architecture: any
Section: libs
Multi-Arch: same
Depends: libavogadro2-1t64 (= ${binary:Version}),
         libeigen3-dev,
         libglew-dev,
         libglvnd-dev,
         openbabel,
         ${misc:Depends}
Recommends: molequeue
Replaces: libavogadro2-1t64 (<< 1.97.0-3)
Breaks: libavogadro2-1t64 (<< 1.97.0-3)
Description: Molecular Graphics and Modelling System (development files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the development and header files.

Package: libavogadro-data
Architecture: all
Section: libdevel
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Molecular Graphics and Modelling System (data files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides molecule and crystal data for the
 Insert Fragment plugin.

Package: libavogadro-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax, ${misc:Depends}
Suggests: libavogadro-dev, python3-avogadro
Description: Molecular Graphics and Modelling System (lib documentation)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the documentation for libavogadro.

Package: python3-avogadro
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Molecular Graphics and Modelling System (Python 3 module)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the Python 3 module.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs -Wl,--as-needed

PYTHON3_VERSION     := $(shell py3versions -dv)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON3_VERSION).so),)
PYTHON3_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON3_VERSION).so
else
PYTHON3_LIBRARY=/usr/lib/libpython$(PYTHON3_VERSION).so
endif

empty :=
space := $(empty)$(empty)

# Qt/GL support is broken on ARM, see Bug#798408
# The problem is triggered by the overlayaxes plugin
# so skip this plugin on arm.
# arm64 currently builds but that could change in the future
ARCH_NO_GL_LIST := armel armhf
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_NO_GL_LIST)$(space)))
  OVERLAYAXES_CONFIG := -DUSE_QT_OPENGL=OFF
else
  OVERLAYAXES_CONFIG := -DUSE_QT_OPENGL=ON
endif


CMAKE_OPTS=-DUSE_HDF5=ON \
	    -DUSE_LIBMSYM=OFF \
	    -DUSE_MMTF=OFF \
	    -DOpenGL_GL_PREFERENCE=GLVND \
	    -DCMAKE_SKIP_RPATH=TRUE \
	    -DUSE_PYTHON=ON \
	    -DUSE_VTK=OFF \
	    -DUSE_QT=ON -DQT_VERSION=6 \
	    -DENABLE_TRANSLATIONS=ON \
	    $(OVERLAYAXES_CONFIG)

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_configure-indep:
	dh_auto_configure -- -DBUILD_DOCUMENTATION=ON $(CMAKE_OPTS)

execute_after_dh_auto_build-indep:
	cd obj-$(DEB_HOST_GNU_TYPE); make documentation

execute_after_dh_auto_install-arch:
	cp -r obj-$(DEB_HOST_GNU_TYPE)/bin debian/tmp/usr

execute_after_dh_auto_install-indep:
	cp -r obj-$(DEB_HOST_GNU_TYPE)/docs/html debian/tmp
	rm -f debian/tmp/usr/share/avogadro2/fragments/.gitignore
